
oo::class create mixer1 {
  constructor {} {
    puts "Mixer1 Constructor"
    catch {next}
  }
  method show {} {
    puts "Mixer1 Show"
    catch {next}
  }
}

oo::class create mixer2 {
  constructor {} {
    puts "Mixer2 Constructor"
    catch {next}
  }
  method show {} {
    puts "Mixer2 Show"
    catch {next}
  }
}

oo::class create top {
  mixin mixer2
  constructor {} {
    puts "Top Constructor"
    catch {next}
  }
  method show {} {
    puts "Top Show"
    catch {next}
  }
}

oo::class create middle {
  superclass top;
  constructor {} {
    puts "Middle Constructor"
    catch {next}
  }
  method show {} {
    puts "Middle Show"
    catch {next}
  }
}

oo::class create bottom {
  superclass middle;
  mixin mixer1;
  constructor {} {
    puts "Bottom Constructor"
    catch {next}
  }
  method show {} {
    puts "Bottom Show"
    catch {next}
  }
}


bottom create test

oo::objdefine test method show {} {
    puts "Defined Show"; 
    catch {next}
}


puts "CLASS CALL"
foreach link [info class call bottom show] {
  puts $link
}
puts "OBJECT CALL"
foreach link [info object call test show] {
  puts $link
}

# Define a new method in class 'top'
oo::define top method testfilter {args} {
    puts "top filter"; 
    next
}

# Define a new method in class 'middle'
oo::define middle method testfilter {args} {
    puts "middle filter"; 
    next
}

# Add the new methods as filters
oo::define top filter testfilter 
oo::define middle filter testfilter 

puts "\nCLASS CALL after adding filter"
foreach link [info class call bottom show] {
  puts $link
}
puts "OBJECT CALL after adding filter"
foreach link [info object call test show] {
  puts $link
}

puts "\ninvocation"
test show

oo::define bottom forward testforward my show 

puts "\nCLASS CALL for testforward"
foreach link [info class call bottom testforward] {
  puts $link
}

puts "\nOBJECT CALL for testforward"
foreach link [info object call test testforward] {
  puts $link
}

puts "info class forward: [info class forward bottom testforward]"
puts "\nForwarded Invocation"
test testforward

