proc findClasses {parent  }  {
  set childClasses [info class subclasses $parent]
  if {$childClasses eq ""} {
    return
  } else {
    set children $childClasses
    foreach cl $childClasses {
      # To protect from looping, confirm that
      # each class is only included once.
      foreach gch [findClasses $cl] {
        if {[lsearch $children $gch] < 0} {
          lappend children $gch
        }
      }
    }
    return $children
  }
}


proc serializeAllClasses {} {
  foreach cl [findClasses oo::object] {
    set comment "# Rebuilding members of class $cl"
    foreach obj [info class instances $cl] {
  
      # Check that an object is truly a member of this
      # class.
      # A mixin class will report objects that include 
      # the mixin.  
      if {[info object class $obj] eq $cl} {
  
        set ns [info object namespace $obj]
  
        # Check to see if this object was created with
        # a 'new' or 'create' command, to rebuild correctly.
        if {$ns eq $obj} {
          set cmd "new "
        } else {
          set cmd "create [string trim $obj ::]"
        }
        append cmds "$comment\n"
        append cmds "set obj \[$cl $cmd {} \]\n"
        append cmds "set ns \[info object namespace \$obj]\n"
        foreach var [info object vars $obj] {
          if {[catch {array get ${ns}::$var} arrayDef]} {
            append cmds \
	        "set \${ns}::$var [list [set ${ns}::$var]]\n"
          } else {
            append cmds \
	        "array set \${ns}::$var [list $arrayDef]\n"
          }
        }
      }
      set comment ""
    }
  }
  return $cmds
}

puts [serializeAllClasses]

